#!/bin/bash

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
# INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
# PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
# CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
# OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# This is a sample bash script that configures each OpenVZ container 
# script name: ./nfs-storage-contents/103.sh
# example:
# $1 102 - CTID
# $2 i55 - head node
# This script assumes that you have prepared your OpenVZ container with CTID 103 and 
# put its compressed contents under the name 103.tar.gz into the same directory with 103.sh

# For any questions, please refer to:
# http://hpc-sched.cs.sfu.ca/

cd /root/103/
cp 103.conf 103-copy.conf

sed -i 's/IP_ADDRESS="192.168.196.239"/IP_ADDRESS="192.168.0.'$1'"/g' 103-copy.conf
sed -i 's/NAMESERVER="192.168.196.3"/NAMESERVER="192.168.0.102"/g' 103-copy.conf
sed -i 's/HOSTNAME="marina"/HOSTNAME="vz'$1'"/g' 103-copy.conf
mv 103-copy.conf /etc/vz/conf/$1.conf
cp 103.mount /etc/vz/conf/$1.mount

cp -pr ./private/ /vz/private/$1/
cp -pr ./root/ /vz/root/$1/
sed -i 's/pbsserver sdc-23/pbsserver '$2'/g' /vz/private/$1/etc/torque/mom/config
echo $2 > /vz/private/$1/etc/torque/server_name
cp -pr /home/storage2/pbs_mom /vz/private/$1/etc/init.d/pbs_mom

cp -pr /root/.ssh/* /vz/private/$1/home/sergey/.ssh/
chown -R sergey /vz/private/$1/home/sergey/
cd /vz/private/$1/home/sergey/.ssh/
chmod 600 *
chmod go-w /vz/private/$1/home/sergey/ /vz/private/$1/home/sergey/.ssh/
rm -f /vz/private/$1/home/sergey/*.sh.o*
chmod 777 /vz/private/$1/tmp/

echo "$1" >> /home/storage2/container-ctids.txt
echo "vz$1 np=4" >> /home/storage2/nodes
echo "192.168.0.$1" >> /home/storage2/container-ips.txt
echo "192.168.0.$1 vz$1" >> /home/storage2/hosts

