#!/bin/bash

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
# INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
# PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
# CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
# OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# This is a sample bash script that launches the framework on every node 
# script name: ./nfs-storage-contents/hpc-upon-boot.sh
# This script assumes Clavis is installed in the framework.

# For any questions, please refer to:
# http://hpc-sched.cs.sfu.ca/


ulimit -u 500000
echo 1004800 > /proc/sys/net/core/optmem_max
echo 20480 > /proc/sys/net/core/somaxconn
echo 2560000 > /proc/sys/vm/max_map_count
echo 32192 > /proc/sys/net/ipv4/tcp_max_syn_backlog
echo 630 > /proc/sys/net/ipv4/tcp_keepalive_intvl
echo 65 > /proc/sys/net/ipv4/tcp_keepalive_probes
echo 1024 65535 > /proc/sys/net/ipv4/ip_local_port_range
echo 100000 > /proc/sys/net/core/netdev_max_backlog
echo 3600 > /proc/sys/net/ipv4/tcp_keepalive_time
echo 3600 > /proc/sys/net/ipv4/tcp_fin_timeout
echo 95 > /proc/sys/net/ipv4/tcp_retries1
echo 3600 > /proc/sys/net/ipv4/tcp_retries2
echo 250 > /proc/sys/net/ipv4/tcp_syn_retries
echo 250 > /proc/sys/net/ipv4/tcp_synack_retries
echo 0 > /proc/sys/net/ipv4/tcp_tw_recycle
echo 0 > /proc/sys/net/ipv4/tcp_tw_reuse


route del -net 192.168.0.0 netmask 255.255.255.0 eth0
route add -net 192.168.0.0 netmask 255.255.255.0 eth0

sleep 10

/etc/init.d/iptables stop
/etc/init.d/vz restart
/etc/init.d/ipmi start
modprobe sch_netem

sleep 10

for i in `cat /home/storage2/container-ctids.txt`;  do vzctl start $i; done
for i in `cat /home/storage2/container-ips.txt`;  do for j in `cat /home/storage2/container-ips.txt`;  do iptables -A FORWARD -d $i -s $j; done; done

HOSTNAME=`hostname`
CLAVIS_RUNDIR="/home/storage2/clavis-rundir-$HOSTNAME"
rm -rf $CLAVIS_RUNDIR
cp -pr /home/storage2/clavis-rundir- $CLAVIS_RUNDIR

screen -S $HOSTNAME -X quit
screen -A -m -d -S $HOSTNAME
screen -S $HOSTNAME -p 0 -X stuff ". $CLAVIS_RUNDIR/scheduler_script.sh &"
sleep 5
screen -S $HOSTNAME -p 0 -X stuff $'\012'

